力扣第746题 使用最小花费爬楼梯 c++ 动态规划

题目

746. 使用最小花费爬楼梯

简单

相关标签

数组 动态规划

给你一个整数数组 cost ,其中 cost[i] 是从楼梯第 i 个台阶向上爬需要支付的费用。一旦你支付此费用,即可选择向上爬一个或者两个台阶。

你可以选择从下标为 0 或下标为 1 的台阶开始爬楼梯。

请你计算并返回达到楼梯顶部的最低花费。

示例 1:

复制代码
输入:cost = [10,15,20]
输出:15
解释:你将从下标为 1 的台阶开始。
- 支付 15 ,向上爬两个台阶,到达楼梯顶部。
总花费为 15 。

示例 2:

复制代码
输入:cost = [1,100,1,1,1,100,1,1,100,1]
输出:6
解释:你将从下标为 0 的台阶开始。
- 支付 1 ,向上爬两个台阶,到达下标为 2 的台阶。
- 支付 1 ,向上爬两个台阶,到达下标为 4 的台阶。
- 支付 1 ,向上爬两个台阶,到达下标为 6 的台阶。
- 支付 1 ,向上爬一个台阶,到达下标为 7 的台阶。
- 支付 1 ,向上爬两个台阶,到达下标为 9 的台阶。
- 支付 1 ,向上爬一个台阶,到达楼梯顶部。
总花费为 6 。

提示:

  • 2 <= cost.length <= 1000
  • 0 <= cost[i] <= 999

思路和解题方法

  1. 首先,获取cost数组的大小,即台阶的数量。
  2. 然后,创建一个大小为n+1的数组dp,用于保存到达每个台阶的最小花费。数组的下标表示台阶的编号,数组的值表示到达该台阶的最小花费。
  3. 接着,对于前两个台阶(下标为0和1),将它们的最小花费初始化为0,因为从这两个台阶起步不需要花费。
  4. 然后,使用动态规划的思想计算到达每个台阶的最小花费。从第2个台阶开始遍历到第n个台阶,在每次循环中,将到达前一个台阶和到达前两个台阶的最小花费加上当前台阶的花费,取较小值赋给当前台阶的最小花费,即dp[i] = min(dp[i-1]+cost[i-1],dp[i-2]+cost[i-2])。
  5. 最后,返回到达最后一个台阶的最小花费,即dp[n]。

复杂度

时间复杂度:

O(n)

时间复杂度为O(n),其中n是台阶的数量,因为需要遍历从第3个台阶到第n个台阶,每次计算都需要常数时间。

空间复杂度

O(n)

空间复杂度为O(n),因为创建了一个大小为n的数组dp来保存到达每个台阶的最小花费。

c++ 代码

cpp 复制代码
class Solution {
public:
    int minCostClimbingStairs(vector<int>& cost) {
        // 获取cost数组的大小
        int n = cost.size();
        
        // 创建一个大小为n+1的数组dp,用于保存到达每个台阶的最小花费
        vector<int> dp(n+1);
        
        // 初始化前两个台阶的最小花费为0
        dp[0] = 0;
        dp[1] = 0;
        
        // 使用动态规划的思想计算到达每个台阶的最小花费
        for(int i=2;i<=n;i++)
        {
            // 到达当前台阶的最小花费等于到达前一个台阶和到达前两个台阶的最小花费加上当前台阶的花费的较小值
            dp[i] = min(dp[i-1]+cost[i-1],dp[i-2]+cost[i-2]);
        }
        
        // 返回到达最后一个台阶的最小花费
        return dp[n];
    }
};

附上常数空间代码

cpp 复制代码
class Solution {
public:
    int minCostClimbingStairs(vector<int>& cost) {
        // 初始化dp0和dp1为到达前两个台阶的最小花费,初始值均为0
        int dp0 = 0;
        int dp1 = 0;
        
        // 使用动态规划的思想计算到达每个台阶的最小花费
        for (int i = 2; i <= cost.size(); i++) {
            // 计算到达当前台阶的最小花费
            int dpi = min(dp1 + cost[i - 1], dp0 + cost[i - 2]);
            
            // 更新dp0和dp1的值,将dp1的值作为下一次循环中的dp0,将dpi的值作为下一次循环中的dp1
            dp0 = dp1; // 记录一下前两位
            dp1 = dpi;
        }
        
        // 返回到达最后一个台阶的最小花费,即dp1
        return dp1;
    }
};

觉得有用的话可以点点赞,支持一下。

如果愿意的话关注一下。会对你有更多的帮助。

每天都会不定时更新哦 >人< 。

相关推荐
leobertlan6 小时前
痛苦系列 | DSP-03 跨越单位圆:Z变换与零极点分析
算法·程序员
蛋蛋的就会顺顺的6 小时前
hot100 p0——栈,贪心算法,动态规划
java·前端·javascript·算法·leetcode·力扣
开发小能手1237 小时前
答案daanC语言
数据结构·算法
Navigator_Z9 小时前
LeetCode //C - 1291. Sequential Digits
c语言·算法·leetcode
WL学习笔记10 小时前
C & C++ 内存管理
c++·c++内存管理
pride.li10 小时前
第03章 Python 教程-基础语法:注释与变量
服务器·前端·后端·python·算法·计算机视觉
旺仔仔仔11 小时前
机器人项目实战(5):从单次抓取,到接收指令连续做事
算法
旺仔仔仔11 小时前
机器人项目实战(2):识别物体、提取点云,再到抓取姿态
算法
姜鱼问生11 小时前
密码明明一样,为什么 GPG 说“错的“?
后端·算法·架构
启观川11 小时前
数据结构与算法-第 3 章 常用算法-贪心算法
数据结构·笔记·python·算法·贪心算法